<!-------------------------------------------------------------------------------
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 -------------------------------------------------------------------------------->

<table [dataSource]="appEntries" [trackBy]="trackBy" cdk-table
       class="openk-table statement-table openk-table---without-last-border">

  <caption hidden>{{ "shared.statementTable.caption" | translate}}</caption>

  <tr *cdkHeaderRowDef="appColumns; sticky: true" cdk-header-row>
  </tr>

  <tr *cdkRowDef="let myRowData; columns: appColumns" cdk-row>
  </tr>

  <ng-container cdkColumnDef="select">
    <th *cdkHeaderCellDef="let statementHeader"
        cdk-header-cell
        class="statement-table--select"
        scope="col">
    </th>
    <td *cdkCellDef="let statement"
        cdk-cell
        class="statement-table--select"
        [class.statement-table--row]="statement.departmentStandIn">
      <div class="statement-table--select--container">
        <input #inputElement
               (keydown.enter)="inputElement.click()"
               (ngModelChange)="$event ? select(statement.id) : deselect(statement.id)"
               [class.cursor-pointer]="!appDisabled"
               [disabled]="appDisabled"
               [ngModel]="statement?.isSelected"
               class="statement-table--select--input"
               type="checkbox">
      </div>
    </td>
  </ng-container>

  <ng-container *ngIf="'id'; let label" cdkColumnDef="id">
    <th *cdkHeaderCellDef="let statementHeader"
        (click)="click(label, sorting[label])"
        [class.cursor-pointer]="appIsSortable"
        cdk-header-cell
        class="statement-table--id"
        scope="col">
      <div class="statement-table--header statement-table--header---right">
        {{"shared.statementTable.id" | translate}}
        <mat-icon
          *ngIf="sorting[label]"
          [class.statement-table--header--icon---rotate]="sorting[label] ==='asc'"
          class="statement-table--header--icon">
          play_arrow
        </mat-icon>
      </div>
    </th>
    <td *cdkCellDef="let statement" cdk-cell
        class="openk-no-whitespace-wrap statement-table--id"
        [class.statement-table--row]="statement.departmentStandIn">
      <div class="openk-no-whitespace-wrap openk-right statement-table--id--container">
        <mat-icon *ngIf="appShowAlert && (statement | statementTableAlert: forMyDepartment)"
                  class="statement-table--icon statement-table--id--icon openk-warning">
          priority_high
        </mat-icon>
        {{statement?.id}}
      </div>
    </td>
  </ng-container>

  <ng-container *ngIf="'title'; let label" cdkColumnDef="title">
    <th *cdkHeaderCellDef="let statementHeader"
        (click)="click(label, sorting[label])"
        [class.cursor-pointer]="appIsSortable"
        cdk-header-cell
        class="statement-table--title"
        scope="col">
      <div class="statement-table--header">
        {{"shared.statementTable.title" | translate}}
        <mat-icon
          *ngIf="sorting[label]"
          [class.statement-table--header--icon---rotate]="sorting[label] ==='asc'"
          class="statement-table--header--icon">
          play_arrow
        </mat-icon>
      </div>
    </th>
    <td *cdkCellDef="let statement" cdk-cell
        class="statement-table--title"
        [class.statement-table--row]="statement.departmentStandIn">
      {{statement?.title}}
      {{statement?.departmentStandIn ? "*" : ""}}
    </td>
  </ng-container>

  <ng-container *ngIf="'city'; let label" cdkColumnDef="city">
    <th *cdkHeaderCellDef="let statementHeader"
        (click)="click(label, sorting[label])"
        [class.cursor-pointer]="appIsSortable"
        cdk-header-cell
        class="statement-table--city"
        scope="col">
      <div class="statement-table--header">
        {{"shared.statementTable.city" | translate}}
        <mat-icon
          *ngIf="sorting[label]"
          [class.statement-table--header--icon---rotate]="sorting[label] ==='asc'"
          class="statement-table--header--icon">
          play_arrow
        </mat-icon>
      </div>
    </th>
    <td *cdkCellDef="let statement" cdk-cell
        class="statement-table--city"
        [class.statement-table--row]="statement.departmentStandIn">
      {{statement?.city}}
    </td>
  </ng-container>

  <ng-container *ngIf="'district'; let label" cdkColumnDef="district">
    <th *cdkHeaderCellDef="let statementHeader"
        (click)="click(label, sorting[label])"
        [class.cursor-pointer]="appIsSortable"
        cdk-header-cell
        class="statement-table--district"
        scope="col">
      <div class="statement-table--header">
        {{"shared.statementTable.district" | translate}}
        <mat-icon
          *ngIf="sorting[label]"
          [class.statement-table--header--icon---rotate]="sorting[label] ==='asc'"
          class="statement-table--header--icon">
          play_arrow
        </mat-icon>
      </div>
    </th>
    <td *cdkCellDef="let statement" cdk-cell
        class="statement-table--district"
        [class.statement-table--row]="statement.departmentStandIn">
      {{statement?.district}}
    </td>
  </ng-container>

  <ng-container *ngIf="'typeId'; let label" cdkColumnDef="type">
    <th (click)="click(label, sorting[label])"
        *cdkHeaderCellDef="let statementHeader;"
        [class.cursor-pointer]="appIsSortable"
        cdk-header-cell
        class="statement-table--type"
        scope="col">
      <div class="statement-table--header">
        {{"shared.statementTable.statementType" | translate}}
        <mat-icon
          *ngIf="sorting[label]"
          [class.statement-table--header--icon---rotate]="sorting[label] ==='asc'"
          class="statement-table--header--icon">
          play_arrow
        </mat-icon>
      </div>
    </th>
    <td *cdkCellDef="let statement" cdk-cell
        class="openk-no-whitespace-wrap statement-table--type"
        [class.statement-table--row]="statement.departmentStandIn">
      {{ (appStatementTypeOptions | selected : statement?.typeId)?.label }}
    </td>
  </ng-container>

  <ng-container *ngIf="'creationDate'; let label" cdkColumnDef="creationDate">
    <th *cdkHeaderCellDef="let statementHeader"
        (click)="click(label, sorting[label])"
        [class.cursor-pointer]="appIsSortable"
        cdk-header-cell
        class="statement-table--date"
        scope="col">
      <div class="statement-table--header">
        {{"shared.statementTable.creationDate" | translate}}
        <mat-icon
          *ngIf="sorting[label]"
          [class.statement-table--header--icon---rotate]="sorting[label] ==='asc'"
          class="statement-table--header--icon">
          play_arrow
        </mat-icon>
      </div>
    </th>
    <td *cdkCellDef="let statement" cdk-cell
        class="openk-no-whitespace-wrap statement-table--date"
        [class.statement-table--row]="statement.departmentStandIn">
      {{statement?.creationDate ? (statement.creationDate | appMomentPipe).format(appTimeDisplayFormat) : ""}}
    </td>
  </ng-container>

  <ng-container *ngIf="'receiptDate'; let label" cdkColumnDef="receiptDate">
    <th *cdkHeaderCellDef="let statementHeader"
        (click)="click(label, sorting[label])"
        [class.cursor-pointer]="appIsSortable"
        cdk-header-cell
        class="statement-table--date"
        scope="col">
      <div class="statement-table--header">
        {{"shared.statementTable.receiptDate" | translate}}
        <mat-icon
          *ngIf="sorting[label]"
          [class.statement-table--header--icon---rotate]="sorting[label] ==='asc'"
          class="statement-table--header--icon">
          play_arrow
        </mat-icon>
      </div>
    </th>
    <td *cdkCellDef="let statement" cdk-cell
        class="openk-no-whitespace-wrap statement-table--date"
        [class.statement-table--row]="statement.departmentStandIn">
      {{statement?.receiptDate ? (statement.receiptDate | appMomentPipe).format(appTimeDisplayFormat) : ""}}
    </td>
  </ng-container>

  <ng-container *ngIf="'departmentsDueDate'; let label" cdkColumnDef="departmentsDueDate">
    <th *cdkHeaderCellDef="let statementHeader"
        (click)="click(label, sorting[label])"
        [class.cursor-pointer]="appIsSortable"
        cdk-header-cell
        class="statement-table--date"
        scope="col">
      <div class="statement-table--header">
        {{"shared.statementTable.departmentsDueDate" | translate}}
        <mat-icon
          *ngIf="sorting[label]"
          [class.statement-table--header--icon---rotate]="sorting[label] ==='asc'"
          class="statement-table--header--icon">
          play_arrow
        </mat-icon>
      </div>
    </th>
    <td *cdkCellDef="let statement" cdk-cell
        class="openk-no-whitespace-wrap statement-table--date"
        [class.statement-table--row]="statement.departmentStandIn">
      {{statement?.departmentsDueDate ? (statement.departmentsDueDate | appMomentPipe).format(appTimeDisplayFormat) : ""}}
    </td>
  </ng-container>

  <ng-container *ngIf="'dueDate'; let label" cdkColumnDef="dueDate">
    <th *cdkHeaderCellDef="let statementHeader"
        (click)="click(label, sorting[label])"
        [class.cursor-pointer]="appIsSortable"
        cdk-header-cell
        class="statement-table--date"
        scope="col">
      <div class="statement-table--header">
        {{"shared.statementTable.dueDate" | translate}}
        <mat-icon
          *ngIf="sorting[label]"
          [class.statement-table--header--icon---rotate]="sorting[label] ==='asc'"
          class="statement-table--header--icon">
          play_arrow
        </mat-icon>
      </div>
    </th>
    <td *cdkCellDef="let statement" cdk-cell
        class="openk-no-whitespace-wrap statement-table--date"
        [class.statement-table--row]="statement.departmentStandIn">
      {{statement?.dueDate ? (statement.dueDate | appMomentPipe).format(appTimeDisplayFormat) : ""}}
    </td>
  </ng-container>

  <ng-container cdkColumnDef="currentTaskName">
    <th *cdkHeaderCellDef="let statementHeader"
        cdk-header-cell
        class="statement-table--tasks"
        scope="col">
      {{"shared.statementTable.currentTaskName" | translate}}
    </th>
    <td *cdkCellDef="let statement" cdk-cell
        class="statement-table--tasks"
        [class.statement-table--row]="statement.departmentStandIn">
      {{statement?.currentTaskName}}
    </td>
  </ng-container>

  <ng-container cdkColumnDef="contributions">
    <th *cdkHeaderCellDef="let statementHeader"
        cdk-header-cell
        class="statement-table--contributions"
        scope="col">
      {{"shared.statementTable.contributions" | translate}}
    </th>
    <td *cdkCellDef="let statement" cdk-cell
        class="statement-table--contributions"
        [class.statement-table--row]="statement.departmentStandIn">
      <span class="openk-no-whitespace-wrap">
        {{statement?.contributionStatus}}
        <mat-icon *ngIf="appShowContributionStatusForMyDepartment"
                  [class.openk-success]="statement?.contributionStatusForMyDepartment"
                  [class.statement-table--contributions--icon---hidden]="statement?.contributionStatusForMyDepartment === false"
                  class="statement-table--icon statement-table--contributions--icon">
            check
        </mat-icon>
      </span>
    </td>
  </ng-container>

  <ng-container cdkColumnDef="anchor">
    <th *cdkHeaderCellDef="let statementHeader"
        cdk-header-cell
        class="statement-table--anchor"
        scope="col">
    </th>
    <td *cdkCellDef="let statement" cdk-cell
        class="statement-table--anchor"
        [class.statement-table--row]="statement.departmentStandIn">
      <a [queryParams]="{id: statement.id}"
         [routerLink]="'/details'"
         [target]="appOpenStatementInNewTab ? '_blank' : undefined"
         class="openk-button openk-button-rounded openk-info statement-table--button">
        <mat-icon>call_made</mat-icon>
      </a>
    </td>
  </ng-container>

</table>
